"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.assign");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _theming = require("@storybook/theming");

var _reactResizeDetector = _interopRequireDefault(require("react-resize-detector"));

var _memoizerific = _interopRequireDefault(require("memoizerific"));

var _router = require("@storybook/router");

var _mobile = require("./components/layout/mobile");

var _desktop = require("./components/layout/desktop");

var _nav = _interopRequireDefault(require("./containers/nav"));

var _preview = _interopRequireDefault(require("./containers/preview"));

var _panel = _interopRequireDefault(require("./containers/panel"));

var _settings = _interopRequireDefault(require("./settings"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Reset = _theming.styled.div(function (_ref) {
  var theme = _ref.theme;
  return {
    fontFamily: theme.mainTextFace,
    color: theme.mainTextColor,
    background: theme.mainBackground,
    WebkitFontSmoothing: 'antialiased',
    fontSize: theme.mainTextSize,
    position: 'fixed',
    top: 0,
    right: 0,
    bottom: 0,
    left: 0,
    width: '100vw',
    height: '100vh',
    overflow: 'hidden'
  };
});

var createProps = (0, _memoizerific.default)(1)(function () {
  return {
    Nav: _nav.default,
    Preview: _preview.default,
    Panel: _panel.default,
    pages: [{
      key: 'settings',
      render: function render() {
        return _react.default.createElement(_settings.default, null);
      },
      // eslint-disable-next-line react/prop-types
      route: function route(_ref2) {
        var children = _ref2.children;
        return _react.default.createElement(_router.Route, {
          path: "/settings",
          startsWith: true
        }, children);
      }
    }]
  };
});

var App = _react.default.memo(function (_ref3) {
  var viewMode = _ref3.viewMode,
      layout = _ref3.layout;
  var props = createProps();
  return _react.default.createElement(Reset, null, _react.default.createElement(_reactResizeDetector.default, {
    handleWidth: true
  }, function (width) {
    if (width === 0) {
      return _react.default.createElement("div", null);
    }

    if (width < 600) {
      return _react.default.createElement(_mobile.Mobile, _extends({}, props, {
        viewMode: viewMode
      }));
    }

    return _react.default.createElement(_desktop.Desktop, _extends({}, props, {
      viewMode: viewMode,
      options: layout
    }));
  }));
});

App.propTypes = {
  viewMode: _propTypes.default.string.isRequired,
  layout: _propTypes.default.shape({}).isRequired
};
App.displayName = 'App';
var _default = App;
exports.default = _default;