"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Draggable", {
  enumerable: true,
  get: function get() {
    return _reactDraggable.default;
  }
});
exports.Handle = void 0;

require("core-js/modules/es6.object.assign");

var _reactDraggable = _interopRequireDefault(require("react-draggable"));

var _theming = require("@storybook/theming");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Handle = _theming.styled.div(function (_ref) {
  var theme = _ref.theme,
      isDragging = _ref.isDragging;
  return {
    zIndex: 10,
    position: 'absolute',
    top: 0,
    left: 0,
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    color: isDragging ? theme.highlightColor : theme.mainBorderColor,
    overflow: 'hidden',
    transition: 'color 0.2s linear, background-position 0.2s linear, background-size 0.2s linear, background 0.2s linear',
    '&:hover': {
      color: theme.highlightColor
    }
  };
}, function (_ref2) {
  var axis = _ref2.axis;
  return {
    cursor: axis === 'x' ? 'col-resize' : 'row-resize'
  };
}, function (_ref3) {
  var theme = _ref3.theme,
      axis = _ref3.axis,
      offset = _ref3.offset;
  return axis === 'x' ? {
    height: '100%',
    width: theme.layoutMargin,
    marginLeft: offset ? -theme.layoutMargin / 2 : 0
  } : {
    height: theme.layoutMargin,
    width: '100%',
    marginTop: offset ? -theme.layoutMargin / 2 : 0
  };
}, {
  '&:after': {
    content: '""',
    display: 'block',
    height: '2px',
    borderColor: 'currentColor'
  }
}, function (_ref4) {
  var theme = _ref4.theme,
      axis = _ref4.axis;
  return axis === 'x' ? {
    '&:after': {
      width: '2px',
      height: theme.layoutMargin * 2,
      borderLeft: '1px solid currentColor',
      borderRight: '1px solid currentColor'
    }
  } : {
    '&:after': {
      height: '2px',
      width: theme.layoutMargin * 2,
      borderTop: '1px solid currentColor',
      borderBottom: '1px solid currentColor'
    }
  };
}, function (_ref5) {
  var shadow = _ref5.shadow,
      isDragging = _ref5.isDragging;

  if (shadow === 'top') {
    var style = {
      background: "radial-gradient(at center center,rgba(0,0,0,0.6) 0%,transparent 70%,transparent 100%)",
      backgroundSize: '100% 50px',
      backgroundPosition: '50% 0',
      backgroundRepeat: 'no-repeat'
    };
    return isDragging ? style : Object.assign({}, style, {
      backgroundPosition: '50% 10px',
      '&:hover': style
    });
  }

  if (shadow === 'left') {
    var _style = {
      background: "radial-gradient(at center center,rgba(0,0,0,0.6) 0%,transparent 70%,transparent 100%)",
      backgroundSize: '50px 100%',
      backgroundPosition: '0 50%',
      backgroundRepeat: 'no-repeat'
    };
    return isDragging ? _style : Object.assign({}, _style, {
      backgroundPosition: '10px 50%',
      '&:hover': _style
    });
  }

  return {};
});

exports.Handle = Handle;