"use strict";

require("core-js/modules/es6.object.assign");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.object.create");

require("core-js/modules/es6.object.set-prototype-of");

var _global = require("global");

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = require("@storybook/react");

var _theming = require("@storybook/theming");

var _desktop = require("./desktop");

var _mobile = require("./mobile");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var PlaceholderBlock = _theming.styled.div(function (_ref) {
  var color = _ref.color;
  return {
    background: color || 'hotpink',
    position: 'absolute',
    top: 0,
    right: 0,
    bottom: 0,
    left: 0,
    width: '100%',
    height: '100%',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    overflow: 'hidden'
  };
});

var PlaceholderClock =
/*#__PURE__*/
function (_Component) {
  _inherits(PlaceholderClock, _Component);

  function PlaceholderClock() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, PlaceholderClock);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(PlaceholderClock)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      count: 1
    };
    return _this;
  }

  _createClass(PlaceholderClock, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.interval = (0, _global.setInterval)(function () {
        var count = _this2.state.count;

        _this2.setState({
          count: count + 1
        });
      }, 1000);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var interval = this.interval;
      clearInterval(interval);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color;
      var count = this.state.count;
      return _react.default.createElement(PlaceholderBlock, {
        color: color
      }, _react.default.createElement("h2", {
        style: {
          position: 'absolute',
          bottom: 0,
          right: 0,
          color: 'rgba(0,0,0,0.2)',
          fontSize: '150px',
          lineHeight: '150px',
          margin: '-20px'
        }
      }, count), children);
    }
  }]);

  return PlaceholderClock;
}(_react.Component);

PlaceholderClock.displayName = "PlaceholderClock";
PlaceholderClock.propTypes = {
  children: _propTypes.default.node.isRequired,
  color: _propTypes.default.string.isRequired
};

var Nav = function Nav(props) {
  return _react.default.createElement(PlaceholderClock, {
    color: "hotpink"
  }, _react.default.createElement("pre", null, JSON.stringify(props, null, 2)));
};

Nav.displayName = "Nav";

var Preview = function Preview(props) {
  return _react.default.createElement(PlaceholderClock, {
    color: "deepskyblue"
  }, _react.default.createElement("pre", null, JSON.stringify(props, null, 2)));
};

Preview.displayName = "Preview";

var Panel = function Panel(props) {
  return _react.default.createElement(PlaceholderClock, {
    color: "orangered"
  }, _react.default.createElement("pre", null, JSON.stringify(props, null, 2)));
};

Panel.displayName = "Panel";

var Page = function Page(props) {
  return _react.default.createElement(PlaceholderClock, {
    color: "cyan"
  }, _react.default.createElement("pre", null, JSON.stringify(props, null, 2)));
};

Page.displayName = "Page";
var props = {
  Nav: Nav,
  Preview: Preview,
  Panel: Panel,
  pages: [],
  options: {
    isFullscreen: false,
    showNav: true,
    showPanel: true,
    panelPosition: 'right'
  },
  location: new URL('http://localhost:9011/?path=/components/UI-DesktopLayout-noNav'),
  path: '/story/UI-DesktopLayout-noNav',
  viewMode: 'story',
  storyId: 'UI-DesktopLayout-noNav'
};
(0, _react2.storiesOf)('UI|Desktop layout', module).add('default', function () {
  return _react.default.createElement(_desktop.Desktop, props);
}).add('no Nav', function () {
  return _react.default.createElement(_desktop.Desktop, _extends({}, props, {
    options: Object.assign({}, props.options, {
      showNav: false
    })
  }));
}).add('no Panel', function () {
  return _react.default.createElement(_desktop.Desktop, _extends({}, props, {
    options: Object.assign({}, props.options, {
      showPanel: false
    })
  }));
}).add('bottom Panel', function () {
  return _react.default.createElement(_desktop.Desktop, _extends({}, props, {
    options: Object.assign({}, props.options, {
      panelPosition: 'bottom'
    })
  }));
}).add('full', function () {
  return _react.default.createElement(_desktop.Desktop, _extends({}, props, {
    options: Object.assign({}, props.options, {
      isFullscreen: true
    })
  }));
}).add('no Panel, no Nav', function () {
  return _react.default.createElement(_desktop.Desktop, _extends({}, props, {
    options: Object.assign({}, props.options, {
      showPanel: false,
      showNav: false
    })
  }));
}).add('page', function () {
  return _react.default.createElement(_desktop.Desktop, _extends({}, props, {
    pages: [{
      key: 'settings',
      // eslint-disable-next-line react/prop-types
      route: function route(_ref2) {
        var children = _ref2.children;
        return _react.default.createElement(_react.Fragment, null, children);
      },
      render: function render() {
        return _react.default.createElement(Page, null);
      }
    }],
    viewMode: undefined
  }));
});
(0, _react2.storiesOf)('UI|Mobile layout', module).add('initial 0', function () {
  return _react.default.createElement(_mobile.Mobile, _extends({}, props, {
    options: {
      initialActive: 0
    }
  }));
}).add('initial 1', function () {
  return _react.default.createElement(_mobile.Mobile, _extends({}, props, {
    options: {
      initialActive: 1
    }
  }));
}).add('initial 2', function () {
  return _react.default.createElement(_mobile.Mobile, _extends({}, props, {
    options: {
      initialActive: 2
    }
  }));
}).add('page', function () {
  return _react.default.createElement(_mobile.Mobile, _extends({}, props, {
    options: {
      initialActive: 1
    },
    pages: [{
      key: 'settings',
      // eslint-disable-next-line react/prop-types
      route: function route(_ref3) {
        var children = _ref3.children;
        return _react.default.createElement(_react.Fragment, null, children);
      },
      render: function render() {
        return _react.default.createElement(Page, null);
      }
    }],
    viewMode: undefined
  }));
});