"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BarItem = exports.Bar = void 0;

var _react = _interopRequireDefault(require("react"));

var _theming = require("@storybook/theming");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _router = require("@storybook/router");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Bar = _theming.styled.ul(function (_ref) {
  var theme = _ref.theme;
  return {
    display: 'flex',
    margin: 0,
    padding: 0,
    borderRadius: theme.mainBorderRadius,
    overflow: 'hidden',
    background: theme.barFill,
    justifyContent: 'space-between',
    height: 40,
    marginTop: 20
  };
});

exports.Bar = Bar;

var BarLi = _theming.styled.li(function (_ref2) {
  var active = _ref2.active,
      theme = _ref2.theme;
  return {
    display: 'block',
    margin: 0,
    padding: 0,
    flex: 1,
    background: active ? 'rgba(255,255,255,0.2)' : 'transparent',
    borderTop: '2px solid transparent',
    borderBottom: active ? "2px solid ".concat(theme.highlightColor) : '2px solid transparent',
    '& > a': {
      cursor: 'pointer',
      color: 'inherit',
      display: 'block',
      padding: 10,
      textAlign: 'center'
    }
  };
});

var BarItem = function BarItem(_ref3) {
  var path = _ref3.path,
      children = _ref3.children,
      active = _ref3.active;
  return _react.default.createElement(BarLi, {
    active: active
  }, _react.default.createElement(_router.Link, {
    to: path
  }, children));
};

exports.BarItem = BarItem;
BarItem.displayName = "BarItem";
BarItem.propTypes = {
  path: _propTypes.default.string.isRequired,
  children: _propTypes.default.node.isRequired,
  active: _propTypes.default.bool
};
BarItem.defaultProps = {
  active: false
};