"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StoriesExplorer = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.array.index-of");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.replace");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _theming = require("@storybook/theming");

var _components = require("@storybook/components");

var _router = require("@storybook/router");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var strip = function strip(href) {
  var viewMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'story';
  return href.replace('#!', "/".concat(viewMode, "/"));
};

var StyledLink = _react.default.memo((0, _theming.styled)(_router.Link)({
  display: 'flex',
  alignItems: 'center',
  color: 'inherit',
  textDecoration: 'none'
}));

StyledLink.displayName = 'StyledLink';

var LeafLink = _react.default.memo(function (_ref) {
  var href = _ref.href,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["href", "children"]);

  return _react.default.createElement(_router.Location, null, function (_ref2) {
    var viewMode = _ref2.viewMode;
    return _react.default.createElement(StyledLink, _extends({
      to: strip(href, viewMode)
    }, rest), children);
  });
});

LeafLink.propTypes = {
  href: _propTypes.default.string.isRequired,
  children: _propTypes.default.node.isRequired
}; // eslint-disable-next-line react/no-multi-comp

var StoriesPanel = _react.default.memo(function (props) {
  return _react.default.createElement(_components.Explorer, _extends({
    allowClick: true
  }, props, {
    Link: LeafLink
  }));
});

exports.StoriesExplorer = StoriesPanel;
StoriesPanel.propTypes = {
  stories: _propTypes.default.shape({}).isRequired,
  storyId: _propTypes.default.string
};
StoriesPanel.defaultProps = {
  storyId: undefined
};