"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MenuToggle = exports.createMenu = void 0;

require("core-js/modules/es6.array.index-of");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.array.map");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _theming = require("@storybook/theming");

var _components = require("@storybook/components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var createMenu = function createMenu(items) {
  return (// eslint-disable-next-line react/prop-types
    items ? function (_ref) {
      var hide = _ref.hide;
      return _react.default.createElement(Menu, {
        hide: hide,
        items: items
      });
    } : _react.default.createElement("div", null)
  );
};

exports.createMenu = createMenu;

var Menu = _react.default.memo(function (_ref2) {
  var hide = _ref2.hide,
      items = _ref2.items;
  return _react.default.createElement(_components.List, null, items.map(function (m) {
    return _react.default.createElement(_components.Item, {
      key: m.id,
      onClick: function onClick() {
        m.action();
        hide();
      }
    }, _react.default.createElement(_components.Icon, {
      type: m.icon
    }), _react.default.createElement(_components.Title, null, m.title), typeof m.detail === 'string' ? _react.default.createElement(_components.Detail, null, m.detail) : m.detail);
  }));
});

Menu.displayName = 'Menu';
Menu.propTypes = {
  items: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string.isRequired,
    title: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.string]).isRequired,
    action: _propTypes.default.func.isRequired,
    detail: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.string]),
    icon: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.string])
  })).isRequired,
  hide: _propTypes.default.func.isRequired
};

var RoundButton = _theming.styled.button(function (props) {
  return Object.assign({
    height: 28,
    width: 28,
    border: '1px solid #eee',
    position: 'relative',
    borderRadius: 14,
    boxSizing: 'border-box',
    background: 'transparent',
    cursor: 'pointer',
    '.popup-content + &, &:focus': {
      border: '1px solid #00aaff',
      outline: '0 none',
      boxShadow: '0 1px 5px 0 rgba(0, 0, 0, 0.1)'
    }
  }, props.highlighted && {
    '&:after': {
      content: '""',
      position: 'absolute',
      top: -1,
      right: -1,
      width: 8,
      height: 8,
      borderRadius: 4,
      background: '#66bf3c'
    }
  }, {
    '& > *': {
      position: 'absolute',
      top: 5,
      left: 5,
      width: 'calc(100% - 10px)',
      height: 'calc(100% - 10px)'
    }
  });
});

var MenuToggle = function MenuToggle(_ref3) {
  var children = _ref3.children,
      props = _objectWithoutProperties(_ref3, ["children"]);

  return _react.default.createElement(_components.Popout, null, _react.default.createElement(RoundButton, props, _react.default.createElement(_components.Icons, {
    icon: "ellipsis"
  })), children);
};

exports.MenuToggle = MenuToggle;
MenuToggle.displayName = "MenuToggle";
MenuToggle.propTypes = {
  children: _propTypes.default.node.isRequired
};