"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.string.link");

require("core-js/modules/es6.array.map");

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _theming = require("@storybook/theming");

var _notifications = require("./notifications");

var _menu = require("./menu");

var _explorer = require("./explorer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var Container = _theming.styled.nav(function (_ref) {
  var theme = _ref.theme;
  return {
    background: theme.asideFill,
    position: 'absolute',
    zIndex: 1,
    left: 0,
    top: 0,
    bottom: 0,
    right: 0,
    width: '100%',
    height: '100%',
    boxSizing: 'border-box'
  };
});

var Inner = _theming.styled.div({
  position: 'absolute',
  zIndex: 1,
  left: 0,
  top: 0,
  bottom: 0,
  right: 0,
  width: '100%',
  display: 'flex',
  flexDirection: 'column',
  justifyContent: 'space-between',
  alignItems: 'stretch',
  padding: 20,
  overflow: 'auto',
  minHeight: '100%',
  boxSizing: 'border-box'
});

var Head = _theming.styled.div({
  display: 'flex',
  alignItems: 'flex-start',
  marginRight: -10,
  marginBottom: 15
});

var Main = _theming.styled.div({
  flex: 1
});

var Foot = _theming.styled.div({});

var A = _theming.styled.a({
  color: 'inherit',
  textDecoration: 'none'
});

var HeadMain = _theming.styled.div({
  flex: 1,
  marginRight: 30
});

var Brand = (0, _theming.withTheme)(function (_ref2) {
  var title = _ref2.title,
      url = _ref2.url,
      UserBrand = _ref2.theme.brand;
  return _react.default.createElement(HeadMain, null, typeof UserBrand === 'function' ? UserBrand({
    title: title,
    url: url
  }) : _react.default.createElement(A, {
    href: url,
    tabIndex: "-1"
  }, title));
});
Brand.displayName = 'Brand';

var Nav = function Nav(_ref3) {
  var title = _ref3.title,
      url = _ref3.url,
      storyId = _ref3.storyId,
      _ref3$notifications = _ref3.notifications,
      notifications = _ref3$notifications === void 0 ? [] : _ref3$notifications,
      stories = _ref3.stories,
      items = _ref3.menu,
      menuHighlighted = _ref3.menuHighlighted;
  return _react.default.createElement(Container, null, _react.default.createElement(Inner, null, _react.default.createElement(Main, null, _react.default.createElement(Head, null, _react.default.createElement(Brand, {
    title: title,
    url: url
  }), _react.default.createElement(_menu.MenuToggle, {
    highlighted: menuHighlighted,
    id: "storybook-explorer-menu"
  }, (0, _menu.createMenu)(items))), _react.default.createElement(_explorer.StoriesExplorer, {
    stories: stories,
    storyId: storyId
  })), _react.default.createElement(Foot, null, notifications.map(function (_ref4) {
    var id = _ref4.id;
    return _react.default.createElement(_notifications.NotificationSpacer, {
      key: id
    });
  }))), notifications.length ? _react.default.createElement(_notifications.Notifications, null, notifications.map(function (_ref5) {
    var id = _ref5.id,
        icon = _ref5.icon,
        content = _ref5.content,
        level = _ref5.level,
        link = _ref5.link;
    return link ? _react.default.createElement(_notifications.NotificationLink, {
      to: link,
      key: id,
      level: level
    }, icon ? _react.default.createElement(_react.Fragment, null, _react.default.createElement(_notifications.NotificationIcon, null, icon), _react.default.createElement(_notifications.NotificationText, null, content)) : _react.default.createElement(_notifications.NotificationText, null, content)) : _react.default.createElement(_notifications.Notification, {
      key: id,
      level: level
    }, icon ? _react.default.createElement(_react.Fragment, null, _react.default.createElement(_notifications.NotificationIcon, null, icon), _react.default.createElement(_notifications.NotificationText, null, content)) : _react.default.createElement(_notifications.NotificationText, null, content));
  })) : null);
};

Nav.displayName = "Nav";
Nav.propTypes = {
  title: _propTypes.default.string.isRequired,
  url: _propTypes.default.string.isRequired,
  stories: _propTypes.default.shape({}).isRequired,
  storyId: _propTypes.default.string,
  notifications: _propTypes.default.arrayOf(_propTypes.default.shape({})).isRequired,
  menu: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string.isRequired,
    title: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.string]).isRequired,
    action: _propTypes.default.func.isRequired,
    detail: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.string]),
    icon: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.string])
  })).isRequired,
  menuHighlighted: _propTypes.default.bool.isRequired
};
Nav.defaultProps = {
  storyId: undefined
};
Nav.displayName = 'Nav';
var _default = Nav;
exports.default = _default;