"use strict";

require("core-js/modules/es6.object.assign");

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@storybook/react");

var _router = require("@reach/router");

var _theming = require("@storybook/theming");

var _nav = _interopRequireDefault(require("./nav"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var theme = _theming.themes.dark;
var props = {
  title: 'Title',
  url: 'https://example.com',
  notifications: [],
  stories: {}
};
(0, _react2.storiesOf)('UI|Nav/settings', module).addDecorator(function (fn) {
  return _react.default.createElement(_router.ServerLocation, {
    url: "http://localhost:9011/?path=/settings"
  }, fn());
}).add('with brand', function () {
  return _react.default.createElement(_theming.ThemeProvider, {
    theme: Object.assign({}, theme)
  }, _react.default.createElement(_nav.default, props));
}).add('without brand', function () {
  return _react.default.createElement(_theming.ThemeProvider, {
    theme: Object.assign({}, theme, {
      brand: null
    })
  }, _react.default.createElement(_nav.default, props));
});
(0, _react2.storiesOf)('UI|Nav/story', module).addDecorator(function (fn) {
  return _react.default.createElement(_router.ServerLocation, {
    url: "http://localhost:9011/?path=/story/UI-MobileLayout-initial0"
  }, fn());
}).add('story', function () {
  return _react.default.createElement(_nav.default, props);
});