"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Notifications = exports.NotificationSpacer = exports.NotificationIcon = exports.NotificationText = exports.Notification = exports.NotificationLink = void 0;

var _theming = require("@storybook/theming");

var _router = require("@storybook/router");

var levelStyle = function levelStyle(_ref) {
  var level = _ref.level,
      theme = _ref.theme;

  switch (level) {
    case 0:
      {
        return {
          background: theme.failColor
        };
      }

    case 1:
      {
        return {
          background: theme.warnColor
        };
      }

    default:
      {
        return {
          background: theme.highlightColor
        };
      }
  }
};

var baseStyle = {
  padding: '5px 10px',
  display: 'flex',
  margin: 10,
  alignItems: 'center',
  justifyContent: 'center',
  height: 48,
  borderRadius: 10,
  backgroundColor: 'rgba(50, 53, 71, 0.97)',
  boxShadow: '0 5px 15px 0 rgba(0, 0, 0, 0.1), 0 2px 5px 0 rgba(0, 0, 0, 0.05)',
  color: 'white',
  textDecoration: 'none',
  userSelect: 'none'
};
var NotificationLink = (0, _theming.styled)(_router.Link)(levelStyle, baseStyle);
exports.NotificationLink = NotificationLink;

var Notification = _theming.styled.div(levelStyle, baseStyle);

exports.Notification = Notification;

var NotificationText = _theming.styled.span({
  flex: 1
});

exports.NotificationText = NotificationText;

var NotificationIcon = _theming.styled.span({
  width: 20
});

exports.NotificationIcon = NotificationIcon;

var NotificationSpacer = _theming.styled.div({
  height: 60
});

exports.NotificationSpacer = NotificationSpacer;

var Notifications = _theming.styled.div({
  position: 'absolute',
  display: 'block',
  bottom: 0,
  margin: 0,
  padding: 0,
  width: '100%',
  zIndex: 2
});

exports.Notifications = Notifications;