"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _global = require("global");

var _key_events = _interopRequireWildcard(require("../libs/key_events"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var _default = function _default(_ref) {
  var store = _ref.store,
      api = _ref.api;

  var handle = function handle(eventType) {
    var _store$getState = store.getState(),
        _store$getState$layou = _store$getState.layout,
        isFullscreen = _store$getState$layou.isFullscreen,
        showNav = _store$getState$layou.showNav,
        showPanel = _store$getState$layou.showPanel;

    switch (eventType) {
      case _key_events.features.ESCAPE:
        {
          if (isFullscreen) {
            api.toggleFullscreen();
          } else if (!showNav) {
            api.toggleNav();
          }

          _global.document.activeElement.blur();

          break;
        }

      case _key_events.features.FOCUS_NAV:
        {
          if (isFullscreen) {
            api.toggleFullscreen();
          }

          if (!showNav) {
            api.toggleNav();
          }

          var element = _global.document.getElementById('storybook-explorer-menu');

          if (element) {
            element.focus();
          }

          break;
        }

      case _key_events.features.FOCUS_SEARCH:
        {
          if (isFullscreen) {
            api.toggleFullscreen();
          }

          if (!showNav) {
            api.toggleNav();
          }

          var _element = _global.document.getElementById('storybook-explorer-searchfield');

          if (_element) {
            _element.focus();
          }

          break;
        }

      case _key_events.features.FOCUS_IFRAME:
        {
          var _element2 = _global.document.getElementById('storybook-preview-iframe');

          if (_element2) {
            try {
              // should be like a channel message and all that, but yolo for now
              _element2.contentWindow.focus();
            } catch (e) {//
            }
          }

          break;
        }

      case _key_events.features.FOCUS_PANEL:
        {
          if (isFullscreen) {
            api.toggleFullscreen();
          }

          if (!showPanel) {
            api.togglePanel();
          }

          var _element3 = _global.document.getElementById('storybook-panel-root');

          if (_element3) {
            _element3.focus();
          }

          break;
        }

      case _key_events.features.NEXT_STORY:
        {
          api.jumpToStory(1);
          break;
        }

      case _key_events.features.PREV_STORY:
        {
          api.jumpToStory(-1);
          break;
        }

      case _key_events.features.NEXT_COMPONENT:
        {
          api.jumpToComponent(1);
          break;
        }

      case _key_events.features.PREV_COMPONENT:
        {
          api.jumpToComponent(-1);
          break;
        }

      case _key_events.features.FULLSCREEN:
        {
          api.toggleFullscreen();
          break;
        }

      case _key_events.features.PANEL_VISIBILITY:
        {
          if (isFullscreen) {
            api.toggleFullscreen();
          }

          api.togglePanel();
          break;
        }

      case _key_events.features.NAV_VISIBILITY:
        {
          if (isFullscreen) {
            api.toggleFullscreen();
          }

          api.toggleNav();
          break;
        }

      case _key_events.features.TOOL_VISIBILITY:
        {
          api.toggleToolbar();
          break;
        }

      case _key_events.features.PANEL_POSITION:
        {
          if (isFullscreen) {
            api.toggleFullscreen();
          }

          if (!showPanel) {
            api.togglePanel();
          }

          api.togglePanelPosition();
          break;
        }

      case _key_events.features.ABOUT:
        {
          api.navigate('/settings/about');
          break;
        }

      case _key_events.features.SHORTCUTS:
        {
          api.navigate('/settings/shortcuts');
          break;
        }

      default:
        break;
    }
  };

  return {
    handle: handle,
    bind: function bind() {
      _global.document.addEventListener('keydown', function (e) {
        return handle((0, _key_events.default)(e, store), store);
      });
    }
  };
};

exports.default = _default;