"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.array.reduce");

require("core-js/modules/es6.array.find");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.array.is-array");

var _lodash = _interopRequireDefault(require("lodash.mergewith"));

var _lodash2 = _interopRequireDefault(require("lodash.isequal"));

var _clientLogger = require("@storybook/client-logger");

var _theming = require("@storybook/theming");

var _utils = require("../settings/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shortcuts = (0, _utils.initShortcutKeys)();
var initial = {
  shortcutKeys: (0, _utils.serializedLocalStorage)(shortcuts),
  ui: {
    name: 'STORYBOOK',
    url: 'https://github.com/storybooks/storybook',
    enableShortcuts: true,
    sortStoriesByKind: false,
    sidebarAnimations: true,
    theme: _theming.themes.normal
  },
  layout: {
    isToolshown: true,
    isFullscreen: false,
    showPanel: true,
    showNav: true,
    panelPosition: 'bottom'
  },
  customQueryParams: {}
};

var merge = function merge(a, b) {
  return (0, _lodash.default)({}, a, b, function (objValue, srcValue) {
    if (Array.isArray(srcValue) && Array.isArray(objValue)) {
      srcValue.forEach(function (s) {
        var existing = objValue.find(function (o) {
          return o === s || (0, _lodash2.default)(o, s);
        });

        if (!existing) {
          objValue.push(s);
        }
      });
      return objValue;
    }

    if (Array.isArray(objValue)) {
      _clientLogger.logger.log('the types mismatch, picking', objValue);

      return objValue;
    }

    return undefined;
  });
}; // Returns the initialState of the app


var _default = function _default() {
  for (var _len = arguments.length, additions = new Array(_len), _key = 0; _key < _len; _key++) {
    additions[_key] = arguments[_key];
  }

  return additions.reduce(function (acc, item) {
    return merge(acc, item);
  }, initial);
};

exports.default = _default;