"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.array.index-of");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.array.for-each");

// simple store implementation
var createStore = function createStore(initialState) {
  var state = initialState;
  var listeners = [];

  function notify() {
    listeners.forEach(function (l) {
      return l();
    });
  }

  function setState(patch) {
    if (typeof patch === 'function') {
      state = Object.assign({}, state, patch(state));
    } else {
      state = Object.assign({}, state, patch);
    }

    notify();
  }

  return {
    getState: function getState() {
      return state;
    },
    setState: setState,
    subscribe: function subscribe(listener) {
      listeners.push(listener);
      return function unsubscribe(l) {
        listeners.splice(listeners.indexOf(l), 1);
      };
    }
  };
};

var _default = createStore;
exports.default = _default;