"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fetchLatestVersion;

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.date.now");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

var _global = require("global");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var versionsUrl = 'https://storybook.js.org/versions.json';
var checkInterval = 24 * 60 * 60 * 1000;

function fetchLatestVersion(_x) {
  return _fetchLatestVersion.apply(this, arguments);
}

function _fetchLatestVersion() {
  _fetchLatestVersion = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(currentVersion) {
    var result, time, cacheItem, fromCache, fromFetch, data;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            time = Date.now();
            _context.prev = 1;
            cacheItem = _global.localStorage.getItem('lastUpdateCheck');
            fromCache = cacheItem && JSON.parse(cacheItem); // if last check was more then 24h ago

            if (!(!fromCache || time - fromCache.time > checkInterval)) {
              _context.next = 16;
              break;
            }

            _context.next = 7;
            return Promise.race([(0, _global.fetch)("".concat(versionsUrl, "?current=").concat(currentVersion)), // if fetch is too slow, we won't wait for it
            new Promise(function (res, rej) {
              return setTimeout(rej, 1500);
            })]);

          case 7:
            fromFetch = _context.sent;
            _context.next = 10;
            return fromFetch.json();

          case 10:
            data = _context.sent;
            result = {
              success: true,
              data: data,
              time: time
            };
            _context.next = 14;
            return _global.localStorage.setItem('lastUpdateCheck', JSON.stringify(result));

          case 14:
            _context.next = 17;
            break;

          case 16:
            result = fromCache;

          case 17:
            _context.next = 22;
            break;

          case 19:
            _context.prev = 19;
            _context.t0 = _context["catch"](1);
            result = {
              success: false,
              error: _context.t0,
              time: time
            };

          case 22:
            return _context.abrupt("return", result);

          case 23:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[1, 19]]);
  }));
  return _fetchLatestVersion.apply(this, arguments);
}