"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _components = require("@storybook/components");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _markdownToJsx = _interopRequireDefault(require("markdown-to-jsx"));

var _components2 = require("./components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AboutScreen = function AboutScreen(_ref) {
  var latest = _ref.latest,
      current = _ref.current;
  var updateBallon;
  var canUpdate = latest && latest.version !== current.version;

  if (latest) {
    updateBallon = canUpdate ? _react.default.createElement(_components2.Balloon, null, "Update available") : _react.default.createElement(_components2.Balloon, {
      success: true
    }, "You're up to date");
  }

  return _react.default.createElement(_components2.Container, null, _react.default.createElement(_components2.Wrapper, null, _react.default.createElement(_components2.Title, null, _react.default.createElement(_components2.TitleIcon, null), _react.default.createElement(_components2.TitleText, null, "Storybook ", current.version), updateBallon)), latest ? _react.default.createElement(_components2.Wrapper, null, _react.default.createElement(_components2.Aside, null, _react.default.createElement("div", null, "Latest version"), _react.default.createElement("div", null, _react.default.createElement("strong", null, latest.version))), _react.default.createElement(_markdownToJsx.default, null, latest.info.plain), _react.default.createElement(_components2.FullChangeLogLink, {
    href: "https://github.com/storybooks/storybook/blob/master/CHANGELOG.md"
  }, "Read full changelog")) : _react.default.createElement(_components2.Wrapper, null, "Cannot currently fetch the latest version from Storybook. Try", ' ', _react.default.createElement("a", {
    href: "https://github.com/storybooks/storybook/blob/master/CHANGELOG.md"
  }, "reading the full changelog")), canUpdate && _react.default.createElement(_components2.Wrapper, null, _react.default.createElement(_components2.Upgrade, null, _react.default.createElement(_components.Typography.Heading, null, "Upgrade all storybook packages to latest:"), _react.default.createElement(_components.SyntaxHighlighter, {
    language: "bash",
    copyable: true,
    padded: true,
    bordered: true
  }, "npx npm-check-updates '/storybook/' -u && yarn"), _react.default.createElement("p", null, "Alternatively if you're using a yarn you could run the following command, and check all storybook related packages:"), _react.default.createElement(_components.SyntaxHighlighter, {
    language: "bash",
    copyable: true,
    padded: true,
    bordered: true
  }, "yarn upgrade-interactive --latest"))), _react.default.createElement(_components2.Wrapper, null, _react.default.createElement(_components2.Footer, null, _react.default.createElement(_components.Typography.Link, {
    href: "https://storybook.js.org"
  }, "Storybook docs"), _react.default.createElement(_components.Typography.Link, {
    href: "https://github.com/storybooks/storybook"
  }, "GitHub"), _react.default.createElement(_components.Typography.Link, {
    href: "https://storybook.js.org/support"
  }, "Support"))));
};

exports.default = AboutScreen;
AboutScreen.displayName = "AboutScreen";
AboutScreen.propTypes = {
  current: _propTypes.default.shape({
    version: _propTypes.default.string.isRequired
  }).isRequired,
  latest: _propTypes.default.shape({
    version: _propTypes.default.string.isRequired,
    info: _propTypes.default.shape({
      plain: _propTypes.default.string.isRequired
    }).isRequired
  })
};
AboutScreen.defaultProps = {
  latest: null
};