"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KeyInputWrapper = exports.HotKeyWrapper = exports.Description = exports.KeyLabel = exports.SuccessIcon = exports.Button = exports.HeaderItem = exports.Row = exports.GridHeaderRow = exports.GridWrapper = exports.ColWrapper = exports.Pre = exports.Upgrade = exports.Footer = exports.A = exports.Header = exports.Heading = exports.FullChangeLogLink = exports.Balloon = exports.TextInput = exports.TitleIcon = exports.ExernalLink = exports.Main = exports.Aside = exports.Wrapper = exports.TitleText = exports.Title = exports.Fade = exports.Jiggle = exports.Container = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.array.index-of");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.define-properties");

require("core-js/modules/es6.object.freeze");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _theming = require("@storybook/theming");

var _components = require("@storybook/components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n0%,100% { opacity: 0; }\n  50% { opacity: 1; }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  from, 0%, 100% to{ transform:translate3d(0,0,0); }\n  12.5%, 62.5% { transform:translate3d(-4px,0,0); }\n  37.5%, 87.5% {  transform: translate3d(4px,0,0);  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Container = _theming.styled.div(function (_ref) {
  var theme = _ref.theme;
  return {
    position: 'absolute',
    left: 0,
    top: 0,
    height: '100%',
    width: '100%',
    overflow: 'auto',
    boxSizing: 'border-box',
    paddingTop: 2 * theme.layoutMargin,
    paddingBottom: 2 * theme.layoutMargin,
    paddingLeft: theme.layoutMargin,
    paddingRight: theme.layoutMargin
  };
});

exports.Container = Container;
var Jiggle = (0, _theming.keyframes)(_templateObject());
exports.Jiggle = Jiggle;
var Fade = (0, _theming.keyframes)(_templateObject2());
exports.Fade = Fade;

var Title = _theming.styled.header(function (_ref2) {
  var theme = _ref2.theme;
  return {
    display: 'block',
    flex: 1,
    paddingBottom: 20,
    marginBottom: 20,
    borderBottom: theme.mainBorder
  };
});

exports.Title = Title;

var TitleText = _theming.styled.span({
  fontSize: 30,
  display: 'inline-block',
  lineHeight: '40px',
  fontWeight: 700
});

exports.TitleText = TitleText;

var Wrapper = _theming.styled.div({
  display: 'flex',
  maxWidth: 600,
  margin: '0 auto',
  '@media screen and (max-width: 500px)': {
    display: 'block'
  }
});

exports.Wrapper = Wrapper;

var Aside = _theming.styled.aside({
  width: 160
});

exports.Aside = Aside;

var Main = _theming.styled.main({
  flex: 1
});

exports.Main = Main;

var ExernalLink = function ExernalLink(_ref3) {
  var children = _ref3.children,
      props = _objectWithoutProperties(_ref3, ["children"]);

  return (0, _theming.jsx)("a", _extends({
    target: "_blank",
    rel: "noopener noreferrer"
  }, props), children);
};

exports.ExernalLink = ExernalLink;
ExernalLink.displayName = "ExernalLink";
ExernalLink.propTypes = {
  children: _propTypes.default.node.isRequired
};
var TitleIcon = (0, _theming.styled)(_components.Icons.Storybook)({
  height: 40,
  width: 'auto',
  display: 'inline-block',
  verticalAlign: 'top',
  marginRight: 10
});
exports.TitleIcon = TitleIcon;

var TextInput = _theming.styled.input(function (_ref4) {
  var colorTheme = _ref4.colorTheme,
      theme = _ref4.theme;
  return colorTheme === 'error' ? {
    borderColor: "".concat(theme.failColor),
    animation: "".concat(Jiggle, " 700ms ease-out")
  } : {
    borderColor: 'rgba(0,0,0,0.05)'
  };
}, function (_ref5) {
  var theme = _ref5.theme;
  return {
    position: 'absolute',
    width: '100%',
    height: '100%',
    top: 0,
    boxSizing: 'border-box',
    borderStyle: 'solid',
    padding: theme.layoutMargin,
    background: 'transparent',
    color: '#777',
    fontSize: 16,
    textAlign: 'center',
    letterSpacing: '0.3em',
    margin: '0 1px',
    '&:focus': {
      outline: 'none',
      borderWidth: 3
    }
  };
});

exports.TextInput = TextInput;

var Balloon = _theming.styled.span(function (_ref6) {
  var success = _ref6.success,
      theme = _ref6.theme;
  return success ? {
    background: '#DAFFD1',
    color: '#4DC533'
  } : {
    background: theme.highlightColor,
    color: 'black'
  };
}, {
  float: 'right',
  height: 40,
  boxSizing: 'border-box',
  padding: '10px 25px',
  borderRadius: 20,
  '@media screen and (max-width: 500px)': {
    float: 'none',
    marginTop: 10,
    display: 'block',
    textAlign: 'center'
  }
});

exports.Balloon = Balloon;
var FullChangeLogLink = (0, _theming.styled)(ExernalLink)(function (_ref7) {
  var theme = _ref7.theme;
  return {
    float: 'right',
    fontWeight: 'normal',
    fontSize: 11,
    color: theme.dimmedTextColor
  };
});
exports.FullChangeLogLink = FullChangeLogLink;

var Heading = _theming.styled.h1({
  fontSize: 16
});

exports.Heading = Heading;

var Header = _theming.styled.div({
  display: 'flex',
  flexDirection: 'row',
  justifyContent: 'space-between'
});

exports.Header = Header;
var A = (0, _theming.styled)(ExernalLink)({
  color: 'inherit'
});
exports.A = A;

var Footer = _theming.styled.div(function (_ref8) {
  var theme = _ref8.theme;
  return {
    display: 'flex',
    flex: 1,
    paddingTop: 20,
    marginTop: 20,
    borderTop: theme.mainBorder,
    '& > *': {
      marginLeft: 20
    },
    '& > *:first-child': {
      marginLeft: 0
    }
  };
});

exports.Footer = Footer;

var Upgrade = _theming.styled.div(function (_ref9) {
  var theme = _ref9.theme;
  return {
    flex: 1,
    paddingTop: 20,
    marginTop: 20,
    borderTop: theme.mainBorder
  };
});

exports.Upgrade = Upgrade;

var Pre = _theming.styled.pre({
  overflow: 'auto',
  boxSizing: 'border-box',
  display: 'block'
}); // Shortcuts Components


exports.Pre = Pre;

var ColWrapper = _theming.styled.div({
  flexDirection: 'column',
  display: 'flex',
  maxWidth: 600,
  margin: '0 auto'
});

exports.ColWrapper = ColWrapper;

var GridWrapper = _theming.styled.div({
  display: 'grid',
  gridTemplateColumns: '1fr',
  gridAutoRows: 'minmax(75px, auto)',
  '@media screen and (max-width: 500px)': {
    gridTemplateColumns: '1fr'
  }
});

exports.GridWrapper = GridWrapper;

var GridHeaderRow = _theming.styled.div({
  alignSelf: 'flex-end',
  display: 'grid',
  margin: 10,
  gridTemplateColumns: '1fr 1fr 10px',
  '& > *:last-of-type': {
    gridColumn: '2 / 2',
    justifySelf: 'flex-end',
    gridRow: '1'
  }
});

exports.GridHeaderRow = GridHeaderRow;

var Row = _theming.styled.div(function (_ref10) {
  var theme = _ref10.theme;
  return {
    padding: '15px 0',
    boxSizing: 'border-box',
    borderTop: theme.mainBorder,
    display: 'grid',
    gridTemplateColumns: '1fr 1fr 10px',
    '& > div:first-child': {
      borderTop: '0 none'
    },
    '&:hover': {
      button: {
        visibility: 'visible'
      }
    }
  };
});

exports.Row = Row;

var HeaderItem = _theming.styled.div({
  fontSize: 18,
  fontWeight: 500
});

exports.HeaderItem = HeaderItem;

var Button = _theming.styled.button(function (_ref11) {
  var theme = _ref11.theme;
  return {
    color: theme.menuHighlightColor,
    backgroundColor: theme.highlightColor,
    fontSize: 11,
    whiteSpace: 'nowrap',
    borderStyle: 'none',
    borderWidth: 0,
    padding: '5px 14px',
    borderRadius: 30,
    margin: '6px 6px 6px 0',
    transition: 'all .2s ease',
    cursor: 'pointer',
    '&:hover, &:focus': {
      backgroundColor: theme.menuHighlightColor,
      color: theme.highlightColor,
      outline: '0 none',
      cursor: 'pointer'
    }
  };
});

exports.Button = Button;

var SuccessIcon = _theming.styled.div(function (_ref12) {
  var colorTheme = _ref12.colorTheme,
      theme = _ref12.theme;
  return colorTheme === 'success' ? {
    color: theme.successColor,
    animation: "".concat(Fade, " 6s ease forwards")
  } : {
    opacity: 0
  };
}, {
  background: 'none',
  width: '34px',
  height: '34px',
  alignSelf: 'flex-end',
  display: 'flex',
  justifyContent: 'center',
  border: '0 none',
  padding: 0,
  justifySelf: 'center'
});

exports.SuccessIcon = SuccessIcon;

var KeyLabel = _theming.styled.div({
  display: 'inline-flex',
  margin: '5px'
});

exports.KeyLabel = KeyLabel;

var Description = _theming.styled.div({
  display: 'inline-flex',
  margin: '0 10px',
  alignSelf: 'center',
  fontSize: 16
});

exports.Description = Description;

var HotKeyWrapper = _theming.styled.div({
  height: '100%',
  width: '100%'
});

exports.HotKeyWrapper = HotKeyWrapper;

var KeyInputWrapper = _theming.styled.div({
  position: 'relative',
  display: 'flex',
  width: 100,
  margin: '0 10px',
  flexDirection: 'column',
  justifySelf: 'flex-end'
});

exports.KeyInputWrapper = KeyInputWrapper;