"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _components = require("./components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderTest = function renderTest(Component, props) {
  describe("".concat(Component), function () {
    it('renders correctly', function () {
      var comp = (0, _enzyme.shallow)(_react.default.createElement(Component, props));
      expect(comp).toExist();
    });
  });
};

describe('components', function () {
  renderTest(_components.Container);
  renderTest(_components.Title);
  renderTest(_components.TitleText);
  renderTest(_components.Wrapper);
  renderTest(_components.Aside);
  renderTest(_components.Main);
  renderTest(_components.TitleIcon);
  renderTest(_components.FullChangeLogLink, {
    href: 'www.google.com'
  });
  renderTest(_components.Heading);
  renderTest(_components.Header);
  renderTest(_components.A);
  renderTest(_components.Footer);
  renderTest(_components.Upgrade);
  renderTest(_components.Pre);
  renderTest(_components.ColWrapper);
  renderTest(_components.GridWrapper);
  renderTest(_components.GridHeaderRow);
  renderTest(_components.Row);
  renderTest(_components.HeaderItem);
  renderTest(_components.Button);
  describe('TextInput', function () {
    it('renders correctly', function () {
      var comp = (0, _enzyme.shallow)(_react.default.createElement(_components.TextInput, {
        colorTheme: "error"
      }));
      expect(comp).toExist();
    });
  });
  describe('Balloon', function () {
    it('renders correctly', function () {
      var comp = (0, _enzyme.shallow)(_react.default.createElement(_components.Balloon, null));
      expect(comp).toExist();
    });
  });
  describe('SuccessIcon', function () {
    it('renders correctly', function () {
      var comp = (0, _enzyme.shallow)(_react.default.createElement(_components.SuccessIcon, {
        colorTheme: "success"
      }));
      expect(comp).toExist();
    });
  });
});