"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var global_1 = require("global");
var client_logger_1 = require("@storybook/client-logger");
exports.get = function (item) {
    try {
        var val = global_1.localStorage.getItem(item);
        return val ? JSON.parse(val) : false;
    }
    catch (e) {
        client_logger_1.logger.error(e);
        return false;
    }
};
exports.setAll = function (itemToSet, changes) {
    try {
        var serializedChanges = JSON.stringify(changes);
        global_1.localStorage.setItem(itemToSet, serializedChanges);
    }
    catch (e) {
        client_logger_1.logger.error(e);
    }
};
exports.setItem = function (itemToSet, key, val) {
    var changes = exports.get(itemToSet);
    changes[key] = val;
    try {
        var serializedChanges = JSON.stringify(changes);
        global_1.localStorage.setItem(itemToSet, serializedChanges);
    }
    catch (e) {
        client_logger_1.logger.error(e);
    }
};
