"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.object.create");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es7.object.entries");

require("core-js/modules/es6.array.filter");

var _react = _interopRequireWildcard(require("react"));

var _components = require("@storybook/components");

var _router = require("@storybook/router");

var _persist = require("./persist");

var _utils = require("./utils");

var _components2 = require("./components");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ShortcutsPage =
/*#__PURE__*/
function (_Component) {
  _inherits(ShortcutsPage, _Component);

  function ShortcutsPage(props) {
    var _this;

    _classCallCheck(this, ShortcutsPage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ShortcutsPage).call(this, props));

    _this.duplicateFound = function () {
      var _this$state = _this.state,
          activeInputField = _this$state.activeInputField,
          inputArr = _this$state.inputArr,
          shortcutKeys = _this$state.shortcutKeys;
      var match = Object.entries(shortcutKeys).filter(function (i) {
        return i[0] !== activeInputField && (0, _utils.isShortcutTaken)(inputArr, i[1].value);
      });
      return !!match.length;
    };

    _this.submitKeyHandler = function () {
      var _this$state2 = _this.state,
          inputArr = _this$state2.inputArr,
          shortcutKeys = _this$state2.shortcutKeys,
          activeInputField = _this$state2.activeInputField;

      if (inputArr.length === 0 || shortcutKeys[activeInputField].value.length === 0) {
        return _this.restoreDefault();
      }

      return undefined;
    };

    _this.handleBackspace = function () {
      var _this$state3 = _this.state,
          shortcutKeys = _this$state3.shortcutKeys,
          activeInputField = _this$state3.activeInputField;

      _this.setState(function (state) {
        var updatedArray = state.inputArr;
        updatedArray.splice(-1);
        return {
          inputArr: updatedArray,
          shortcutKeys: Object.assign({}, shortcutKeys, _defineProperty({}, activeInputField, {
            value: updatedArray,
            error: false
          }))
        };
      });
    };

    _this.onKeyDown = function (e) {
      if (e.key === 'Backspace') {
        return _this.handleBackspace(e);
      }

      if (e.key === 'Enter' || e.key === 'Tab') {
        return _this.submitKeyHandler();
      }

      var _this$state4 = _this.state,
          shortcutKeys = _this$state4.shortcutKeys,
          activeInputField = _this$state4.activeInputField;
      var parsedKey = (0, _utils.keyToSymbol)((0, _utils.parseKey)(e)[0]);
      return _this.setState(function (state) {
        var lengthTooLong = [].concat(_toConsumableArray(state.inputArr), [parsedKey]).length > 3;
        var newValue = state.inputArr.length < 3 ? [].concat(_toConsumableArray(state.inputArr), [parsedKey]) : state.inputArr;
        return {
          inputArr: newValue,
          shortcutKeys: Object.assign({}, shortcutKeys, _defineProperty({}, activeInputField, {
            value: newValue,
            error: lengthTooLong
          }))
        };
      });
    };

    _this.onFocus = function (focusedInput) {
      return function () {
        var shortcutKeys = _this.state.shortcutKeys;

        _this.setState({
          activeInputField: focusedInput,
          inputArr: [],
          shortcutKeys: Object.assign({}, shortcutKeys, _defineProperty({}, focusedInput, {
            value: [],
            error: false
          }))
        });
      };
    };

    _this.onBlur = function () {
      var _this$state5 = _this.state,
          shortcutKeys = _this$state5.shortcutKeys,
          inputArr = _this$state5.inputArr,
          activeInputField = _this$state5.activeInputField;

      if (shortcutKeys[activeInputField] && shortcutKeys[activeInputField].value.length === 0) {
        return _this.restoreDefault();
      }

      if (_this.duplicateFound()) {
        return _this.setState({
          shortcutKeys: Object.assign({}, shortcutKeys, _defineProperty({}, activeInputField, {
            value: inputArr,
            error: true
          }))
        });
      }

      return _this.saveShortcut(activeInputField);
    };

    _this.saveShortcut = function () {
      var _this$state6 = _this.state,
          activeInputField = _this$state6.activeInputField,
          inputArr = _this$state6.inputArr,
          shortcutKeys = _this$state6.shortcutKeys;

      _this.setState({
        successField: activeInputField,
        shortcutKeys: Object.assign({}, shortcutKeys, _defineProperty({}, activeInputField, {
          value: inputArr,
          error: false
        }))
      });

      return (0, _persist.setItem)('shortcutKeys', activeInputField, inputArr);
    };

    _this.restoreDefaults = function () {
      _this.setState({
        shortcutKeys: _utils.defaultShortcutSets
      });

      return (0, _persist.setAll)('shortcutKeys', _utils.serializableKeyboardShortcuts);
    };

    _this.restoreDefault = function () {
      var _this$state7 = _this.state,
          activeInputField = _this$state7.activeInputField,
          shortcutKeys = _this$state7.shortcutKeys;

      _this.setState({
        inputArr: _utils.defaultShortcutSets[activeInputField].value,
        shortcutKeys: Object.assign({}, shortcutKeys, _defineProperty({}, activeInputField, _utils.defaultShortcutSets[activeInputField]))
      });

      return (0, _persist.setItem)('shortcutKeys', activeInputField, _utils.serializableKeyboardShortcuts[activeInputField]);
    };

    _this.displaySuccessMessage = function (activeElement) {
      var _this$state8 = _this.state,
          successField = _this$state8.successField,
          shortcutKeys = _this$state8.shortcutKeys;
      return activeElement === successField && shortcutKeys[activeElement].error === false ? 'success' : '';
    };

    _this.displayError = function (activeElement) {
      var _this$state9 = _this.state,
          activeInputField = _this$state9.activeInputField,
          shortcutKeys = _this$state9.shortcutKeys;
      return activeElement === activeInputField && shortcutKeys[activeElement].error === true ? 'error' : '';
    };

    _this.renderKeyInput = function () {
      var shortcutKeys = _this.state.shortcutKeys;
      var arr = Object.entries(shortcutKeys).map(function (shortcut, i) {
        var transformedKeyStr = shortcut[1].value.length ? (0, _utils.mapToKeyEl)(shortcut[1].value).join('') : '';
        return shortcut && _react.default.createElement(_components2.Row, {
          key: "".concat(shortcut[0])
        }, _react.default.createElement(_components2.Description, null, "".concat(_utils.labelsArr[i])), _react.default.createElement(_components2.KeyInputWrapper, null, _react.default.createElement(_components2.HotKeyWrapper, null, _react.default.createElement(_components2.TextInput, {
          spellCheck: "false",
          colorTheme: _this.displayError(shortcut[0]),
          className: "modalInput",
          onBlur: _this.onBlur,
          onFocus: _this.onFocus(shortcut[0]),
          onKeyDown: _this.onKeyDown,
          value: transformedKeyStr
        }))), _react.default.createElement(_components2.SuccessIcon, {
          colorTheme: _this.displaySuccessMessage(shortcut[0])
        }, _react.default.createElement(_components.Icons, {
          height: 20,
          icon: "check"
        })));
      });
      return arr;
    };

    _this.renderKeyForm = function () {
      return _react.default.createElement(_components2.GridWrapper, null, _react.default.createElement(_components2.GridHeaderRow, null, _react.default.createElement(_components2.HeaderItem, null, "Commands"), _react.default.createElement(_components2.HeaderItem, null, "Shortcut")), _this.renderKeyInput());
    };

    var shortcuts = (0, _utils.initShortcutKeys)();
    _this.state = {
      activeInputField: '',
      inputArr: [],
      shortcutKeys: (0, _utils.serializedLocalStorage)(shortcuts),
      successField: ''
    };
    return _this;
  }

  _createClass(ShortcutsPage, [{
    key: "render",
    value: function render() {
      var layout = this.renderKeyForm();
      return _react.default.createElement(_router.Route, {
        path: "shortcuts"
      }, _react.default.createElement(_components2.Container, null, _react.default.createElement(_components2.Wrapper, null, _react.default.createElement(_components2.Title, null, _react.default.createElement(_components2.TitleText, null, "Keyboard Shortcuts"))), _react.default.createElement(_components2.ColWrapper, null, _react.default.createElement(_components2.Main, null, _react.default.createElement(_components2.Heading, null, _react.default.createElement(_components2.Header, null, _react.default.createElement(_components2.Button, {
        id: "restoreDefaultsHotkeys",
        onClick: this.restoreDefaults
      }, "Restore Defaults"))), layout)), _react.default.createElement(_components2.Wrapper, null, _react.default.createElement(_components2.Footer, null, _react.default.createElement(_components2.A, {
        href: "https://storybook.js.org"
      }, "Storybook docs"), _react.default.createElement(_components2.A, {
        href: "https://github.com/storybooks/storybook"
      }, "GitHub"), _react.default.createElement(_components2.A, {
        href: "https://storybook.js.org/support"
      }, "Support")))));
    }
  }]);

  return ShortcutsPage;
}(_react.Component);

ShortcutsPage.displayName = "ShortcutsPage";
var _default = ShortcutsPage;
exports.default = _default;